package com.tzld.longarticle.recommend.server.service.score.strategy;

import com.tzld.longarticle.recommend.server.remote.NLPRemoteService;
import com.tzld.longarticle.recommend.server.service.score.Score;
import com.tzld.longarticle.recommend.server.service.score.ScoreParam;
import com.tzld.longarticle.recommend.server.service.score.ScoreStrategy;
import com.tzld.longarticle.recommend.server.util.CommonCollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @author dyp
 */
@Component
public class SimilarityStrategy implements ScoreStrategy {

    @Autowired
    private NLPRemoteService nlpRemoteService;

    @Override
    public List<Score> score(ScoreParam param) {

        Map<String, Double> scoreMap = nlpRemoteService.score(param.getAccountName(), param.getContents());

        List<Score> scores = CommonCollectionUtils.toList(param.getContents(), c -> {
            Score score = new Score();
            score.setContentId(c.getId());
            score.setScore(scoreMap.get(c.getId()));
            score.setStrategy(this.getClass());
            return score;
        });
        return scores;
    }

}
